#include "stdafx.h"

#pragma comment(lib,"Bcrypt")

char *pKey = "1234567890123456";
char *pPlaintext = "'tbyla pulnoc ve skolni tride...";

int _tmain(int argc, _TCHAR* argv[]) {

    //otevrit handle na algoritmus
    BCRYPT_ALG_HANDLE  hAesAlg = NULL;
    NTSTATUS status = BCryptOpenAlgorithmProvider(&hAesAlg,
                                        BCRYPT_AES_ALGORITHM,
                                        NULL,   // implementace
                                        0);     // flagy (DISPATCH)

    DWORD  cbKeyObject = 0;
    DWORD  cbData = 0;
    status = BCryptGetProperty(hAesAlg,
        BCRYPT_OBJECT_LENGTH,
        (PBYTE)&cbKeyObject,
        sizeof DWORD,
        &cbData,0);

    BYTE   *pbKeyObject = new BYTE[cbKeyObject];
    memset(pbKeyObject,0,cbKeyObject);
 
    // generuje klic ze vstupni bytes
    BCRYPT_KEY_HANDLE hKey = NULL;
    status = BCryptGenerateSymmetricKey(hAesAlg, 
                                       &hKey, 
                                       pbKeyObject, 
                                       cbKeyObject, 
                                       (PBYTE)pKey, 
                                       strlen(pKey), 
                                       0); 

    //BCryptDeriveKey(

    ULONG cbCipherText = 0;
    status = BCryptEncrypt(hKey,
                (PUCHAR)pPlaintext,
                strlen(pPlaintext),
                NULL,
                NULL,
                0,
                NULL,
                0,
                &cbCipherText,
                BCRYPT_BLOCK_PADDING);

    PUCHAR pCipherText = new UCHAR[cbCipherText];
    status = BCryptEncrypt(hKey,
                (PUCHAR)pPlaintext,
                strlen(pPlaintext),
                NULL,
                NULL,
                0,
                pCipherText,
                cbCipherText,
                &cbCipherText,
                BCRYPT_BLOCK_PADDING);

    BCryptDestroyKey(hKey);
    hKey = NULL;

    SecureZeroMemory(pbKeyObject,cbKeyObject);
    delete [] pbKeyObject;
    pbKeyObject = NULL;

    // Zavreme poskytovatele algoritmu
    BCryptCloseAlgorithmProvider(hAesAlg,0);

    return 0;
}

